window.Gleam.initSearch([{"doc":"gloop","title":"gloop","content":"# gloop\n\n[![Package Version](https://img.shields.io/hexpm/v/gloop)](https://hex.pm/packages/gloop)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gloop/)\n\nStack-safe, non-UI blocking &quot;while&quot; and &quot;do while&quot; loops in Gleam to reduce the mental burden caused by recursion.\n\n```sh\ngleam add gloop\n```\nCheck the test folder for an example on how to use the while loop.\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gloop&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"gloop","title":"do_while","content":"pub fn do_while(\n  state state: a,\n  code_to_run code_to_run: fn(a) -&gt; a,\n  post_run_condition post_run_condition: fn(a) -&gt; Bool,\n) -&gt; a\n This `do while` function checks the condition using the communicated state at the end\n of an iteration. It therefore runs the code given to the `do while` function AT LEAST once.\n Just as the other while function, it is stack-safe.\nSynonyms:\ngloop.do_while\ngloop do_while","url":"gloop.html#do_while"},{"doc":"gloop","title":"while","content":"pub fn while(\n  state state: a,\n  pre_run_condition pre_run_condition: fn(a) -&gt; Bool,\n  code_to_run code_to_run: fn(a) -&gt; a,\n) -&gt; a\n This `while` function is stack-safe and checks the condition based on the communicated state\n at the beginning of an iteration.\n If the condition is true then the code handed to the `while` function is run and generates a\n new state in preparation for the next iteration.\n If the condition is false then the code returns the final state and stops.\n As long as the condition is true, the while loop will continue without blowing up the stack.\nSynonyms:\ngloop.while\ngloop while","url":"gloop.html#while"},{"doc":"gloop","title":"gloop","content":" This module called `Gloop` introduces stack-safe, tall-call recursive `while` loops in Gleam.\n The intent is to remove the additional mental burden recursion causes in Gleam.\n\n For an example of how to use this library see gloop_test.gleam in the test folder.","url":"gloop.html"}]);